# -*- coding: utf-8 -*-
import settings
import sys
import os
import sound_notifier
from PyQt4.QtGui import QDialog
from PyQt4.QtGui import QCheckBox
from PyQt4.QtGui import QPushButton
from PyQt4.QtGui import QFileDialog
from PyQt4.QtGui import QHBoxLayout
from PyQt4.QtGui import QVBoxLayout
from PyQt4.QtGui import QGroupBox
from PyQt4.QtGui import QLabel
#from PyQt4.QtCore import *
import vk_api

class settingsDialog(QDialog):
    
    def keyPressEvent(self, event):
        key = event.key()
        if key == 16777216:
            self.cancel()
        
        
    def change_mode_slot(self):
        if self.modeLabel.text()==u'звук':
            self.modeLabel.setText(u'речь')
        else:
            self.modeLabel.setText(u'звук')
            
    def change_msg_slot(self):
        filename = QFileDialog.getOpenFileName(self,u'Выберите звуковой файл',settings.soundpath)
        if filename=='':
            return
        self.msgLabel.setText(filename)
        
    def change_start_slot(self):
        filename = QFileDialog.getOpenFileName(self,u'Выберите звуковой файл',settings.soundpath)
        if filename=='':
            return
        self.startLabel.setText(filename)
        
    def change_close_slot(self):
        filename = QFileDialog.getOpenFileName(self,u'Выберите звуковой файл',settings.soundpath)
        if filename=='':
            return
        self.closeLabel.setText(filename)
        
        
    def saveConf(self):
        modeRes =self.modeLabel.text()
         
        if modeRes==u'звук':
            modeRes='sound'
        else:  
            modeRes='speech'
        msgRes = self.msgLabel.text()
        if msgRes==u'Нет':
            msgRes='None'
        startRes = self.startLabel.text()
        if startRes==u'Нет':
            startRes='None'
        closeRes = self.closeLabel.text()
        if closeRes==u'Нет':
            closeRes='None'
        sound_notifier.SoundNotifier.mute = self.muteMode.isChecked()
        sound_notifier.SoundNotifier.msgSound=msgRes
        sound_notifier.SoundNotifier.startSound=startRes
        sound_notifier.SoundNotifier.closeSound=closeRes
        sound_notifier.SoundNotifier.mode=modeRes
        sound_notifier.SoundNotifier.saveToConfig()
        sound_notifier.SoundNotifier.initSounds()
        self.close()
        
    def cancel(self):
        self.close()
             
    def __init__(self):
        QDialog.__init__(self)
        vbox = QVBoxLayout()
        hbox1 = QHBoxLayout()
        hbox2 = QHBoxLayout()
        hbox3 = QHBoxLayout()
        hbox4 = QHBoxLayout()
        hbox5 = QHBoxLayout()
        group1 = QGroupBox(u'Режим оповещения')
        group1.setLayout(hbox1)
        group2 = QGroupBox(u'Звух входящего сообщения')
        group2.setLayout(hbox2)
        group3 = QGroupBox(u'Звух входа в приложение')
        group3.setLayout(hbox3)
        group4 = QGroupBox(u'Звух выхода из приложения')
        group5 = QGroupBox(u'Беззвучный режим')
        group5.setLayout(hbox5)
        self.muteMode = QCheckBox(u'Включено')
        hbox5.addWidget(self.muteMode)
        group4.setLayout(hbox4)
        vbox.addWidget(group1)
        vbox.addWidget(group2)
        vbox.addWidget(group3)
        vbox.addWidget(group4)
        vbox.addWidget(group5)
        self.setWindowTitle(u'Настройки звука')
        hboxend=QHBoxLayout()
        self.setLayout(vbox)
        saveButton = QPushButton(u"Сохранить")
        cancelButton = QPushButton(u"Отмена")
        hboxend.addWidget(saveButton)
        hboxend.addWidget(cancelButton)
        vbox.addLayout(hboxend)
        saveButton.clicked.connect(self.saveConf)
        cancelButton.clicked.connect(self.cancel)
        changeModeB = QPushButton(u'Сменить')
        changeMsgB = QPushButton(u'Сменить')
        changeStartB = QPushButton(u'Сменить')
        changeCloseB = QPushButton(u'Сменить')
        changeModeB.clicked.connect(self.change_mode_slot)
        changeMsgB.clicked.connect(self.change_msg_slot)
        changeStartB.clicked.connect(self.change_start_slot)
        changeCloseB.clicked.connect(self.change_close_slot)
        
        mode = sound_notifier.SoundNotifier.mode
        if mode =='sound':
            mode=u'звук'
        else:
            mode=u'речь'
        self.modeLabel = QLabel(mode)
        hbox1.addWidget(self.modeLabel)
        hbox1.addWidget(changeModeB)
        msgS = sound_notifier.SoundNotifier.msgSound
        if msgS=='None':
            msgS=u'Нет'
        self.msgLabel = QLabel(msgS)
        hbox2.addWidget(self.msgLabel)
        hbox2.addWidget(changeMsgB)
        startS = sound_notifier.SoundNotifier.startSound
        if startS=='None':
            startS=u'Нет'
        self.startLabel = QLabel(startS)
        hbox3.addWidget(self.startLabel)
        hbox3.addWidget(changeStartB)
        closeS = sound_notifier.SoundNotifier.closeSound
        if closeS=='None':
            closeS=u'Нет'
        self.muteMode.setChecked(sound_notifier.SoundNotifier.mute)
        self.closeLabel = QLabel(closeS)
        hbox4.addWidget(self.closeLabel)
        hbox4.addWidget(changeCloseB)

        