from cx_Freeze import setup, Executable

import platform
import os
import sys
import settings
if platform.system()=="Windows":
    from cx_Freeze.windist import bdist_msi
# Create a structure for the registry table
# This will create a value 'InstallDir' in the key 'HKEY_LOCAL_MACHINE\SOFTWARE\MyCo\hello'
registry_table = [('VK-LiteKeyLM', 2, r'SOFTWARE\AC-Indie\\VK-LITE', '*', None, 'TARGETDIR'),
        ('VK-LiteInstallDir', 2, r'SOFTWARE\AC-Indie\\PassatConfigMaker', 'InstallDir', '[TARGETDIR]', 'TARGETDIR'), ]
# A RegLocator table to find the install directory registry key when upgrading
reg_locator_table = [('VK-LiteInstallDirLocate', 2, r'SOFTWARE\\VK-LITE\\', 'InstallDir', 0)]
# An AppSearch entry so that the MSI will search for previous installs 
# and update the default install location
app_search_table = [('TARGETDIR', 'VK-LiteInstallDirLocate')]
# Now create the table dictionary
msi_data = {'Registry': registry_table, 'RegLocator': reg_locator_table, 'AppSearch': app_search_table}
# Change some default MSI options and specify the use of the above defined tables

bdist_msi_options = {'upgrade_code': '{2b666b99-fe8b-4d21-9e8b-e386cff79ce1}',  # Remember to generate your own GUID for this
        'initial_target_dir': r'[ProgramFilesFolder]\\AC-Indie\\VK-LITE',
        'data': msi_data}

WIN_Target = Executable(script = "home.py",
targetName = "vklite.exe",
compress = True,
appendScriptToLibrary = False,
shortcutName="VK-LITE",
icon = 'icon.ico',
base = "Win32GUI",
shortcutDir="DesktopFolder",
appendScriptToExe = True)

UNIX_Target = Executable(script = "home.py",
targetName = "vklite",
compress = True,
appendScriptToLibrary = False,
appendScriptToExe = True)

if platform.system()=="Windows":
    _executables=[WIN_Target]
else:
    _executables = [UNIX_Target]
    
buildOptions = dict(include_files = ["images"+settings.sys_dirsplitter,"sounds"+settings.sys_dirsplitter,'configs'+settings.sys_dirsplitter])
bdist_msiOptions = dict()
if platform.system()=="Windows": 
    bdist_msiOptions = dict(bdist_msi =  bdist_msi_options)

setup(
    name = "VK-LITE",
    version = "0.3",
    description = "Lightweight client for vkontakte social network",
    options = dict(build_exe = buildOptions,bdist_msi = bdist_msi_options),
    executables = _executables
    )
