# -*- coding: utf-8 -*-

import urllib2,urllib, os
import settings
from PyQt4.QtGui import QMessageBox 
from PyQt4.QtGui import QPushButton
from PyQt4.QtGui import QIcon
from PyQt4.QtGui import QWidget
from PyQt4.QtGui import QFileDialog
from PyQt4.QtGui import QHBoxLayout
import shutil

from PyQt4.QtCore import QThread
from PyQt4.QtCore import QMutex

from time import sleep
import io
import pygame.mixer

import StringIO
from PyQt4.Qt import QString

def mixer_close():
    if pygame.mixer.get_init()!=None:
        pygame.mixer.quit()
        
def mixer_reinit(rate):
    if pygame.mixer.get_init()!=None:
        while pygame.mixer.music.get_busy():
            sleep(0.5)
        mixer_srate,some,some2 = pygame.mixer.get_init() 
        if mixer_srate!=rate:
            pygame.mixer.quit()
            pygame.mixer.init(rate)
            mixer_srate = rate
    else:
        pygame.mixer.init(rate)
            
class MusicPlayer(QWidget):
    played = False
    
    def closeEvent(self, event):
        print "CLOSE PLAYER"
        if self.played:
            MusicPlayer.played = False
            
    def play(self):
        if self.played:
            return self.pause_resume()
        if MusicPlayer.played:
            QMessageBox.critical(None, u'Внимание!', u'Один из плееров уже запущен! Остановите его если хотите запустить другой!')
            return
        mixer_reinit(44100)
        pygame.mixer.music.load(self.song)
        MusicPlayer.played = True
        self.play_button.setIcon(QIcon(settings.images_path+'pause.png'))
        self.played = True
        pygame.mixer.music.play()
        
    def pause_resume(self):
        if self.paused:
            pygame.mixer.music.unpause()
            self.play_button.setIcon(QIcon(settings.images_path+'pause.png'))
            self.paused=False
            return
        self.paused = True
        self.play_button.setIcon(QIcon(settings.images_path+'play.png'))
        pygame.mixer.music.pause()
        
    def save(self):
        songname = (self.song.decode('utf-8'))
        fileName = QFileDialog.getSaveFileName(self,u"Сохранить песню",songname,"mp3 files (*.mp3);;All Files (*)")
        if fileName!='':
            shutil.copy(self.song, unicode(fileName))
            
    def stop(self):
        if self.played:
            MusicPlayer.played = False
            pygame.mixer.music.stop()
            self.play_button.setIcon(QIcon(settings.images_path+'play.png'))
            self.played = False
            self.paused = False
            pygame.mixer.quit()
                
    def forward(self):
        if self.played and not self.paused:
            pos = pygame.mixer.music.get_pos()
            print pos
            newpos = pos+100000
            pygame.mixer.music.stop()
            pygame.mixer.music.load(self.song)
            pygame.mixer.music.play(0,float(newpos))
    
    def backward(self):
        if self.played and not self.paused:
            pos = pygame.mixer.music.get_pos()
            print pos
            pos = pos-10
            if pos>0:
                pygame.mixer.music.stop()
                pygame.mixer.music.load(self.song)
                pygame.mixer.music.play(0,float(pos))
    
            
    def __init__(self,parent=None,song=None,title=None):
        QWidget.__init__(self,parent)
        self.title = title
        hbox = QHBoxLayout()
        if settings.OS=='Windows':
            self.song = song.encode('utf-8')
        else:
            self.song = song
        self.stop_button = QPushButton()
        self.play_button = QPushButton()
        self.played = False
        self.paused = False
        self.forward_button = QPushButton()
        self.backward_button = QPushButton()
        self.save_button = QPushButton()
        hbox.addWidget(self.play_button)
        hbox.addWidget(self.stop_button)
        #hbox.addWidget(self.backward_button)
        #hbox.addWidget(self.forward_button)
        hbox.addWidget(self.save_button)
        self.save_button.setIcon(QIcon(settings.images_path+'save.png'))
        self.save_button.setFixedWidth(48)
        self.stop_button.setIcon(QIcon(settings.images_path+'stop.png'))
        self.stop_button.setFixedWidth(48)
        self.play_button.setIcon(QIcon(settings.images_path+'play.png'))
        self.play_button.setFixedWidth(48)
        self.forward_button.setIcon(QIcon(settings.images_path+'forward.png'))
        self.forward_button.setFixedWidth(48)
        self.backward_button.setIcon(QIcon(settings.images_path+'backward.png'))
        self.backward_button.setFixedWidth(48)
        self.setLayout(hbox)
        self.save_button.clicked.connect(self.save)
        self.play_button.clicked.connect(self.play)
        self.stop_button.clicked.connect(self.stop)
        self.forward_button.clicked.connect(self.forward)
        self.backward_button.clicked.connect(self.backward)
        
        
class soundThread(QThread):
    sounds =['msg','start','close']
    def __init__(self):
        QThread.__init__(self)
        self.listmutex = QMutex()
        self.soundmutex = QMutex()
        self.text_list = []
        self.soundlist = []
    
    
    
    def __speakSpeechFromText(self,phrase):
        word = phrase.encode('utf-8')
        sintez_word = urllib.quote(word)
        url = 'http://translate.google.com/translate_tts?tl=ru&q='+sintez_word
        request = urllib2.Request(url)
        request.add_header('User-agent', "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.19 (KHTML, like Gecko) Ubuntu/12.04 Chromium/18.0.1025.151 Chrome/18.0.1025.151 Safari/535.19") 
        opener = urllib2.build_opener()
        song = StringIO.StringIO(opener.open(request).read())
        mixer_reinit(16000)
        pygame.mixer.music.load(song)
        pygame.mixer.music.play()
         
    def add_text(self,text):
        self.listmutex.lock()
        self.text_list.append(text)
        self.listmutex.unlock()
    
    def add_sound(self,sound):
        if not sound in soundThread.sounds:
            return
        self.soundmutex.lock()
        self.soundlist.append(sound)
        self.soundmutex.unlock()
    
    @staticmethod
    def play_sound(sound):
        if SoundNotifier.mute:
            return
        if sound =='msg':
            soundpath = SoundNotifier.msgSound
        if sound=='start':
            soundpath = SoundNotifier.startSound
        if sound=='close':
            soundpath = SoundNotifier.closeSound
        if soundpath=='None':
            return
        
        try:
            mixer_reinit(16000)
            pygame.mixer.music.load(soundpath)
            pygame.mixer.music.play()
        except:
            pass
             
    def __del__(self):
        self.wait()
        
    def run_speech_mode_iter(self):
        if len(self.text_list)==0:
            sleep(3)
            return
        try:
            self.listmutex.lock()
            text = self.text_list.pop(0)
            self.listmutex.unlock()
            self.__speakSpeechFromText(text)
        except:
            sleep(3)
            
    def run_sound_mode_iter(self):
        if len(self.soundlist)==0:
            sleep(1)
            return
        try:
            self.soundmutex.lock()
            sound = self.soundlist.pop(0)
            self.soundmutex.unlock()
            soundThread.play_sound(sound)
        except:
            sleep(1)
            
    def run(self):
        while(True):
            if SoundNotifier.mode=='speech':
                self.run_speech_mode_iter()
                continue
            else:
                self.run_sound_mode_iter()
                continue
                
            
            
speakerTh = soundThread()
                
class MessageReader():
    
    last_author = 'none'
    @staticmethod
    def speak_text(text):
        if SoundNotifier.mute:
            return
        splitters = ['.','!','?',')','(',',']
        if len(text)>100:
            splitter = -1
            for s in splitters:
                tmp_splitter = text.find(s)
                if tmp_splitter>splitter:
                    splitter=tmp_splitter
            if splitter!=-1:
                part1 = text[:splitter]
                part2 = text[splitter+1:]
                MessageReader.speak_text(part1)
                MessageReader.speak_text(part2)
            else:
                MessageReader.speak_text('Сообщение слишком длинное')
                return
        else:
            global speakerTh
            speakerTh.add_text(text)
    @staticmethod
    def speak_msg(author,text):
        if SoundNotifier.mute:
            return
        if author!=MessageReader.last_author:
            str = author +u" пишет "
            MessageReader.speak_text(str)
            MessageReader.last_author = author
        MessageReader.speak_text(text)

class SoundNotifier():
    mode = 'sound'
    msgSound = 'None'
    startSound = 'None'
    closeSound = 'None'
    mute = False
    
    @staticmethod
    def initSounds():
        while os.path.isfile(settings.sound_config):
            try:
                conf = open(settings.sound_config,'r')
            except:
                break
            for line in conf:
                splitter =line.find('mute=') 
                if not splitter==-1:
                    if line[5:]=='1\n':
                        SoundNotifier.mute= True
                    else:
                        SoundNotifier.mute= False
                    continue
                splitter =line.find('mode=') 
                if not splitter==-1:
                    SoundNotifier.mode = line[5:]
                    SoundNotifier.mode = SoundNotifier.mode[:len(SoundNotifier.mode)-1]
                    continue
                if SoundNotifier.mode=='speak':
                    return
                splitter =line.find('msg=') 
                if not splitter==-1:
                    SoundNotifier.msgSound = line[4:]
                    if SoundNotifier.msgSound.find('\n')!=-1:
                        SoundNotifier.msgSound = SoundNotifier.msgSound[:len(SoundNotifier.msgSound)-1]
                    continue
                splitter =line.find('start=')
                if not splitter==-1:
                    SoundNotifier.startSound = line[6:]
                    if SoundNotifier.startSound.find('\n')!=-1:
                        SoundNotifier.startSound = SoundNotifier.startSound[:len(SoundNotifier.startSound)-1]
                    continue
                splitter =line.find('close=')
                if not splitter==-1:
                    SoundNotifier.closeSound = line[6:]
                    if SoundNotifier.closeSound.find('\n')!=-1:
                        SoundNotifier.closeSound = SoundNotifier.closeSound[:len(SoundNotifier.closeSound)-1]
                    continue
            conf.close()
            return
        if not os.path.isdir(settings.config_path[:len(settings.config_path)-1]):
            os.mkdir(settings.config_path[:len(settings.config_path)-1]) 
        conf = io.open(settings.sound_config,'w+',newline='')
        muteconf = 'mute=0\n'
        msg_conf = "msg="+settings.soundpath+"msg.mp3\n"
        start_conf = "start=None\n"
        close_conf = "close=None\n"
        modeconf = "mode="+SoundNotifier.mode+'\n'
        conf.write(unicode(muteconf))
        conf.write(unicode(modeconf))
        conf.write(unicode(msg_conf))
        conf.write(unicode(start_conf))
        conf.write(unicode(close_conf))
        conf.close()
            
            
    @staticmethod
    def changeSound(soundN,soundpath):
        if soundN=='msg':
            SoundNotifier.msgSound = soundpath
            return
        if soundN=='start':
            SoundNotifier.startSound = soundpath
            return
        if soundN=='close':
            SoundNotifier.closeSound = soundpath
            return
        
    @staticmethod
    def saveToConfig():
        conf = io.open(settings.sound_config,'w+',newline='')
        if SoundNotifier.mute:
            muteconf = "mute=1\n"
        else:
            muteconf = "mute=0\n"
        mode_conf = "mode="+SoundNotifier.mode+'\n'
        msg_conf = "msg="+SoundNotifier.msgSound+'\n'
        start_conf = "start="+SoundNotifier.startSound+'\n'
        close_conf = "close="+SoundNotifier.closeSound+'\n'
        conf.write(unicode(muteconf))
        conf.write(unicode(mode_conf))
        conf.write(unicode(msg_conf))
        conf.write(unicode(start_conf))
        conf.write(unicode(close_conf))
        conf.close()
                    
                
    @staticmethod
    def msgNotify(author,text):
        if MusicPlayer.played:
            return
        if SoundNotifier.mute:
            return
        if SoundNotifier.mode=='sound':
            if SoundNotifier.msgSound=='None':
                return
            global speakerTh
            speakerTh.add_sound('msg')
            #SoundNotifier.play_sound(SoundNotifier.msgSound)
            return
        if SoundNotifier.mode=='speech':
            MessageReader.speak_msg(author, text)
            return
    
    @staticmethod
    def openProgNotify():
        if SoundNotifier.startSound=='None':
            return
        global speakerTh
        speakerTh.add_sound('start')
        #SoundNotifier.play_sound(SoundNotifier.startSound)
    
    @staticmethod
    def closeProgNotify():
        if SoundNotifier.closeSound=='None':
            return
        global speakerTh
        speakerTh.add_sound('close')
        #SoundNotifier.play_sound(SoundNotifier.closeSound)
        
    @staticmethod
    def play_sound(soundpath):
        
        if SoundNotifier.mute:
            return
        try:
            mixer_reinit(16000)
            pygame.mixer.music.load(soundpath)
            pygame.mixer.music.play()
        except:
            pass
    
speakerTh.start()
