# -*- coding: utf-8 -*-
'''
Created on 15 июля 2014 г.

@author: acrap
'''
from PyQt4.QtCore import pyqtSignal
from PyQt4.QtGui import QDialog
from PyQt4.QtGui import QMessageBox
from PyQt4.QtGui import QVBoxLayout
from PyQt4.QtGui import QLabel
from PyQt4.QtGui import QPixmap
from PyQt4.QtGui import QLineEdit
from PyQt4.QtGui import QPushButton

import sys
import settings
import os
import mechanize, urllib, urllib2, json
app_id = '4450293' 
vk = None 
app = None


class LoginDialog(QDialog):
    loginSuccess = pyqtSignal()
    def sign_in(self):
        global vk
        vk = VK()
        vk.email = self.login_in.text()
        vk.password = self.password_in.text()
        if vk.login():
            tokenfile = open(settings.tokenpath,'w')
            tokenfile.write(vk.token)
            tokenfile.close()
            vk.get_friends(vk.myid)
            vk.get_friends_online(vk.myid)
            login_save = open(settings.loginpath,'w')
            login_save.write(self.login_in.text())
            login_save.close()
            self.loginSuccess.emit()
            self.setResult(QDialog.Accepted)
            self.hide()
        else:
            QMessageBox.critical(None, u'Ошибка', u'Неправильные данные для входа')

    def keyPressEvent(self, event):
        key = event.key()
        if key == 16777220 :
            self.sign_in()
            
    def closeEvent(self, event):
        global vk
        if vk==None:
            os.remove(settings.lockpath)
            sys.exit(app)
              
    def __init__(self):
        QDialog.__init__(self)
        self.setResult(QDialog.Rejected)
        layout = QVBoxLayout()
        self.setLayout(layout)
        logo = QLabel()
        login_text=""
        if os.path.isfile(settings.loginpath):
            login_save = open(settings.loginpath,'r')
            login_text = login_save.readline()
            login_save.close()
            
            
        logo.setPixmap(QPixmap(settings.images_path+"logo.png"))
        self.password_in = QLineEdit()
        self.password_in.setEchoMode(QLineEdit.Password)
        #self.password_in.setInputMethodHints(Qt.ImhHiddenText);
        self.login_in = QLineEdit(login_text)
        layout.addWidget(logo)
        layout.addWidget(QLabel(u"Электронная почта"))
        layout.addWidget(self.login_in)
        layout.addWidget(QLabel(u"Пароль"))
        layout.addWidget(self.password_in)
        self.setWindowTitle(u'Вход в систему')
        self.loginButton = QPushButton(u'Войти')
        layout.addWidget(self.loginButton)
        self.loginButton.clicked.connect(self.sign_in)
        
        
class VK(object):
    friends_online = []
    friends = {}
    messages_dic = {}
    unreaded_mes_uid_list = []
    '''
    classdocs
    '''
    
    
    def send_to_api(self,method,data_dic):
        req = "https://api.vkontakte.ru/method/"+method
        data_dic['access_token']=self.token
        try:
            resp = urllib2.urlopen(req, urllib.urlencode(data_dic))
        except:
            return False
        params = json.loads(resp.read())
        return params
    
    def get_video_link_by_id(self,vid):
        data_dic = {'videos':vid}
        result = self.send_to_api("video.get", data_dic)
        if not result:
            return False
        try:
            resp = result['response']
            resp = resp[1]
        except:
            return False
        return resp['player']
    
    def get_audio_link_by_id(self,aid):
        data_dic = {'audios':aid}
        result = self.send_to_api("audio.getById", data_dic)
        if not result:
            return False
        try:
            resp = result['response']
            resp = resp[0]
        except:
            aid = '-'+aid
            data_dic = {'audios':[aid]}
            result = self.send_to_api("audio.getById", data_dic)
            try:
                resp = result['response']
                return resp['url']
            except:
                return False           
            return False
        return resp['url']
    
    def get_message_by_id(self,mid):
        data_dic = {'mid':mid}
        result = self.send_to_api("messages.getById", data_dic)
        if not result:
            return False
        try:
            return result['response']
        except:
            return False
        
    def get_name_by_uid(self,userlist,dic):
        data_dic={'fields':'online'}
        data_dic['uids']=userlist
        result = self.send_to_api("users.get", data_dic)
        if not result:
            return False
        try:
            userdic = result["response"]
        except:
            print result
        for i in range(len(userdic)):
            try:
                elem = userdic[i]
            except:
                break
            uid = elem['uid']
            first_name = elem['first_name']
            last_name = elem['last_name']
            online = elem['online']
            if online=='1':
                online = '*#'
            else:
                online=''
            dic[uid] = first_name+" "+last_name+online
    
    def set_as_online(self,elem,online):
        if online:
            elem = elem+"*#"
        else:
            index = elem.rfind("*#")
            elem = elem[:index]
        
        
    def refresh_online_status(self):
        self.get_friends_online(self.myid)
        for key in self.friends:
            if key in self.friends_online:
                self.set_as_online(self.friends[key], True)
            else:
                self.set_as_online(self.friends[key], False)
        return True    
            
               
    def get_friends_online(self,uid):
        data_dic = {'uid':uid}
        params = self.send_to_api("friends.getOnline", data_dic)
        if not params:
            return False
        friends_online =  params['response']
        for friend in friends_online:
            self.friends_online.append(friend)
        return True
            
        
    def get_friends(self,uid):
        data_dic = {'uid':uid,'fields':['uid','first_name','last_name','online']}
        params = self.send_to_api("friends.get", data_dic)
        if not params:
            return False
        friends =  params['response']
        for friend in friends:
            id = friend['uid']
            last_name = friend['last_name']
            first_name = friend['first_name']
            online = friend['online']
            if online=='1':
                online='*'
            else:
                online=''
            self.friends[id] = first_name+" "+last_name+online
        return True
    
    def get_unread_messages(self):
        data_dic = {'filters':'1'}
        params = self.send_to_api("messages.get", data_dic)
        if not params:
            return False
        try:
            mess_struc = params['response']
        except:
            return False
        return mess_struc    
    
    def mark_dialog_read(self,uid):
        data_dic = {'uid':uid}
        params = self.send_to_api("messages.markAsRead", data_dic)
        if not params:
            return False
        try:
            params['response']
        except:
            return False
        return True
            
    def get_message_history(self,uid,offset = None):
        data_dic = {'uid':uid,'count':'50'}
        if offset!=None:
            data_dic['offset']=offset
        params = self.send_to_api("messages.getHistory", data_dic)
        if not params:
            return False
        mes_dic = params['response']
        count = mes_dic[0]
        messages = []
        result = []
        talk_uid_dic = {}
        id = 0
        for i in range(1,count):
            try:
                message_dic = mes_dic[i]
            except:
                break
            id = message_dic['uid']
            mid = message_dic['mid']
            try:
                message_dic['chat_id']
                continue
            except:
                pass
            if id==self.myid:
                name = u"Я"
            else:
                try:
                    name = talk_uid_dic[str(id)]
                except KeyError:
                    dic ={}
                    self.get_name_by_uid(str(id), dic)
                    for keys in dic:
                        talk_uid_dic[str(id)]=dic[keys]
                    name = talk_uid_dic[str(id)]
            mess_str = str(mid)+"|"+name+" - "+message_dic['body']
            try:
                attachments = message_dic['attachments']
                mess_str = mess_str +" $ATTACH"
                for attach in attachments:
                    if attach['type']==u'audio':
                        mess_str = mess_str +" AUDIO"
                    if attach['type']==u'photo':
                        mess_str = mess_str +" PHOTO"
                    if attach['type']==u'wall':
                        mess_str = mess_str +" WALL"
                    if attach['type']==u'doc':
                        mess_str = mess_str +" DOC"
            except:
                pass
            messages.append(mess_str)            
        for m in messages:
            try:
                #m = m.replace("<br>","\n")
                result.append(unicode(m))
            except:
                result.append("Bad message")
        return result   
    
    def send_attach(self,id,attach):
        data = {
                'uid':id,
                'attachment':attach}
        params = self.send_to_api("messages.send", data)
        if not params:
            return False
        try:
            return params['response']
        except:
            return False
            
    def send_message(self,id, message):
        data = {
                'uid': id,
                'message':message}
        params = self.send_to_api("messages.send", data)
        if not params:
            return False
        try:
            return params['response']
        except:
            return False
        
    def get_token(self,email,password):
        br = mechanize.Browser()
        br.open('https://oauth.vk.com/authorize?client_id=' + app_id + '&scope=friends,docs,photo,audio,groups,video,messages,wall,offline&redirect_uri=http://oauth.vk.com/blank.html&display=wap&v=5.23&response_type=token')
        br.select_form(nr=0)
        br.form['email'] = email
        br.form['pass'] = password
        br.submit()
        try:
            br.select_form(nr=0)
            br.submit()
        except:
            pass
        redirect_url = br.geturl()
        try:
            token = redirect_url.split('token=')[1].split('&')[0]
        except:
            return False
        return token
    
    def get_my_id(self):
        data_dic = {}
        params = self.send_to_api("users.get", data_dic)
        me =  params['response']
        me = me[0]
        return me['uid']
        
    def login(self):
        self.token = self.get_token(self.email, self.password)
        if not self.token:
            return False
        self.myid = vk.get_my_id()
        return True
        
    def __init__(self):
        '''
        Constructor
        '''
        self.token = 0
        self.email = ''
        self.password = ''
        self.myid = 0






    
    

        
        

        
